﻿using System.Collections.ObjectModel;

using CommunityToolkit.Mvvm.ComponentModel;

using MyBusiness.Contracts.ViewModels;
using MyBusiness.Core.Contracts.Services;
using MyBusiness.Core.Models;

namespace MyBusiness.ViewModels;

public partial class SuppliersViewModel : ObservableRecipient, INavigationAware
{
    private readonly ISampleDataService _sampleDataService;

    public ObservableCollection<SampleOrder> Source { get; } = new ObservableCollection<SampleOrder>();

    public SuppliersViewModel(ISampleDataService sampleDataService)
    {
        _sampleDataService = sampleDataService;
    }

    public async void OnNavigatedTo(object parameter)
    {
        Source.Clear();

        // TODO: Replace with real data.
        var data = await _sampleDataService.GetGridDataAsync();

        foreach (var item in data)
        {
            Source.Add(item);
        }
    }

    public void OnNavigatedFrom()
    {
    }
}
